## libcitygml 1.4.3

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.8.2 FATAL_ERROR)

PROJECT ( libcitygml )

set(META_VERSION_MAJOR       "1")
set(META_VERSION_MINOR       "4")
set(META_VERSION_PATCH       "3")

set(META_VERSION             "${META_VERSION_MAJOR}.${META_VERSION_MINOR}.${META_VERSION_PATCH}")

SET( CMAKE_MODULE_PATH "${libcitygml_SOURCE_DIR}/CMakeModules/;${CMAKE_MODULE_PATH}" )

IF(WIN32)

    IF(MSVC)
        SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP")

        # More MSVC specific compilation flags
        ADD_DEFINITIONS(-D_SCL_SECURE_NO_WARNINGS)
        ADD_DEFINITIONS(-D_CRT_SECURE_NO_DEPRECATE)
    ENDIF(MSVC)

    # Both Cygwin and Msys need -DNOMINMAX ???
    IF(UNIX)
        ADD_DEFINITIONS(-DNOMINMAX)
    ENDIF(UNIX)

########################################################################################################
# the foolowing options are MSVC specific,
# the first OSG_MSVC_VERSIONED_DLL activate a custom build-time layout that should allow to run examples and application
# fron bin folder without requiring installation step.
# it also prepend "osg${OPENSCENEGRAPH_SOVERSION}-" to only .dll files, leaving .lib files untouched in lib
# it also use a hack to get rid of Debug and Release folder in MSVC projects
# all the .dll and .pdb are in bin and all the .lib and .exp are in lib
#
# the second option disable incremental linking in debug build , that is enabled by default by CMake
##########################################################################################################

    IF(MSVC)
        # IF(${CMAKE_MAJOR_VERSION} EQUAL 2 AND ${CMAKE_MINOR_VERSION} EQUAL 4 AND ${CMAKE_PATCH_VERSION} LESS 7)
            # MESSAGE("Warning:  disabling versioned options 2.4.6 exibits inconsintencies in .pdb naming, at least under MSVC, suggested upgrading at least to 2.4.7")
            # SET(OSG_MSVC_VERSIONED_DLL OFF)
            # SET(OSG_MSVC_DEBUG_INCREMENTAL_LINK ON)
        # ELSE(${CMAKE_MAJOR_VERSION} EQUAL 2 AND ${CMAKE_MINOR_VERSION} EQUAL 4 AND ${CMAKE_PATCH_VERSION} LESS 7)
            OPTION(LIBCITYGML_MSVC_VERSIONED_DLL "Set to ON to build libcitygml with versioned dll names" ON)
            MARK_AS_ADVANCED(LIBCITYGML_MSVC_VERSIONED_DLL)
            OPTION(LIBCITYGML_MSVC_DEBUG_INCREMENTAL_LINK "Set to OFF to build libcitygml without incremental linking in debug (release is off by default)" ON)
            MARK_AS_ADVANCED(LIBCITYGML_MSVC_DEBUG_INCREMENTAL_LINK)
            IF(NOT LIBCITYGML_MSVC_DEBUG_INCREMENTAL_LINK)
                SET(CMAKE_MODULE_LINKER_FLAGS_DEBUG "/debug /INCREMENTAL:NO")
                SET(CMAKE_SHARED_LINKER_FLAGS_DEBUG "/debug /INCREMENTAL:NO")
                SET(CMAKE_EXE_LINKER_FLAGS_DEBUG "/debug /INCREMENTAL:NO")
            ENDIF(NOT LIBCITYGML_MSVC_DEBUG_INCREMENTAL_LINK)
        # ENDIF(${CMAKE_MAJOR_VERSION} EQUAL 2 AND ${CMAKE_MINOR_VERSION} EQUAL 4 AND ${CMAKE_PATCH_VERSION} LESS 7)
    ENDIF(MSVC)
ENDIF(WIN32)

if(UNIX)
    if(APPLE)
        MESSAGE(STATUS "APPLE")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -fPIC")
    else(APPLE)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -fPIC")

        MESSAGE(STATUS "Setting UNIX compile flags: ${CMAKE_CXX_FLAGS}")
    endif(APPLE)
endif(UNIX)

IF(MSVC_IDE)
  # From CMake 2.8.2, new way to manage output generation dirs !
    # SET_TARGET_PROPERTIES(${LIB_NAME} PROPERTIES PREFIX "../")
    SET( CMAKE_RUNTIME_OUTPUT_DIRECTORY_RELEASE ${PROJECT_BINARY_DIR}/bin)
    SET( CMAKE_RUNTIME_OUTPUT_DIRECTORY_DEBUG ${PROJECT_BINARY_DIR}/bin)

    SET( CMAKE_ARCHIVE_OUTPUT_DIRECTORY_RELEASE ${PROJECT_BINARY_DIR}/lib)
    SET( CMAKE_ARCHIVE_OUTPUT_DIRECTORY_DEBUG ${PROJECT_BINARY_DIR}/lib)

    SET( CMAKE_LIBRARY_OUTPUT_DIRECTORY_RELEASE ${PROJECT_BINARY_DIR}/bin)
    SET( CMAKE_LIBRARY_OUTPUT_DIRECTORY_DEBUG ${PROJECT_BINARY_DIR}/bin)
ENDIF(MSVC_IDE)

SET(CMAKE_DEBUG_POSTFIX  "d")

# Dynamic vs Static Linking
OPTION(LIBCITYGML_DYNAMIC "Set to ON to build libcitygml for dynamic linking.  Use OFF for static." ON)
IF   (LIBCITYGML_DYNAMIC)
    SET(LIBCITYGML_USER_DEFINED_DYNAMIC_OR_STATIC "SHARED")
ELSE (LIBCITYGML_DYNAMIC)
    SET(LIBCITYGML_USER_DEFINED_DYNAMIC_OR_STATIC "STATIC")
ENDIF(LIBCITYGML_DYNAMIC)

SET(OUTPUT_BINDIR ${PROJECT_BINARY_DIR}/bin)
MAKE_DIRECTORY(${OUTPUT_BINDIR})
SET(EXECUTABLE_OUTPUT_PATH ${OUTPUT_BINDIR})

SET(OUTPUT_LIBDIR ${PROJECT_BINARY_DIR}/lib)
MAKE_DIRECTORY(${OUTPUT_LIBDIR})
SET(LIBRARY_OUTPUT_PATH ${OUTPUT_LIBDIR})

# IF( DEBUG_BUILD )
  # SET( CMAKE_BUILD_TYPE "Debug" )
# ELSE( DEBUG_BUILD )
  # SET( CMAKE_BUILD_TYPE "Release" )
# ENDIF( DEBUG_BUILD )

OPTION(LIBCITYGML_STATIC_CRT "Set to ON to link libcitygml with the multithread CRT static library (instead of DLL)." ON)

# gdal library
OPTION(LIBCITYGML_USE_GDAL "Set to ON to build libcitygml with GDAL library so that it supports coordinates transformations." ON)


FIND_PACKAGE( Xerces REQUIRED )

IF( LIBCITYGML_USE_GDAL )
  FIND_PACKAGE( GDAL REQUIRED )
  ADD_DEFINITIONS( -DUSE_GDAL )
ELSE( LIBCITYGML_USE_GDAL )
  SET( GDAL_INCLUDE_DIR "" )
  SET( GDAL_LIBRARY "" )
ENDIF( LIBCITYGML_USE_GDAL )

FIND_PACKAGE( OpenGL REQUIRED )
#FIND_PACKAGE( GLU REQUIRED ) # deprecated, GLU is now found with FindOpenGL

IF( COMMAND cmake_policy )
  cmake_policy( SET CMP0003 NEW )
ENDIF( COMMAND cmake_policy )

IF( MSVC AND LIBCITYGML_STATIC_CRT )
  #We statically link to reduce dependancies
  FOREACH( flag_var CMAKE_CXX_FLAGS CMAKE_CXX_FLAGS_DEBUG CMAKE_CXX_FLAGS_RELEASE CMAKE_CXX_FLAGS_MINSIZEREL CMAKE_CXX_FLAGS_RELWITHDEBINFO )
    IF( ${flag_var} MATCHES "/MD" )
      string( REGEX REPLACE "/MD" "/MT" ${flag_var} "${${flag_var}}" )
    ENDIF( ${flag_var} MATCHES "/MD" )
    IF( ${flag_var} MATCHES "/MDd" )
      string( REGEX REPLACE "/MDd" "/MTd" ${flag_var} "${${flag_var}}" )
    ENDIF( ${flag_var} MATCHES "/MDd" )
  ENDFOREACH( flag_var )
ENDIF( MSVC AND LIBCITYGML_STATIC_CRT )

# core
ADD_SUBDIRECTORY( sources )

# osg plugin
OPTION(LIBCITYGML_OSGPLUGIN "Set to ON to build libcitygml osgplugin programs." OFF)
IF   (LIBCITYGML_OSGPLUGIN)
  ADD_SUBDIRECTORY( osgplugin )
ENDIF(LIBCITYGML_OSGPLUGIN)

# test
OPTION(LIBCITYGML_TESTS "Set to ON to build libcitygml tests programs." ON)
IF   (LIBCITYGML_TESTS)
  ADD_SUBDIRECTORY( test )
ENDIF(LIBCITYGML_TESTS)


#-----------------------------------------------------------------------------
### uninstall target
#-----------------------------------------------------------------------------
CONFIGURE_FILE(
  "${CMAKE_CURRENT_SOURCE_DIR}/CMakeModules/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
  IMMEDIATE @ONLY)
ADD_CUSTOM_TARGET(uninstall
  "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

# Create debian package
option(BUILD_DEBIAN_PACKAGE  "Creates a debian package" ON)
if(BUILD_DEBIAN_PACKAGE)
    # set project description for packaging
    set(META_PROJECT_NAME        "libcitygml")
    set(META_PROJECT_SUMMARY     "Open source C++ library for parsing CityGML files")
    set(META_PROJECT_DESCRIPTION "libcitygml is a small and easy to use open source C++ library for parsing
                                  CityGML files in such a way that data can be easily exploited by 3D
                                  rendering applications (geometry data are tesselated and optimized for
                                  rendering during parsing). For instance, it can be used to develop readers
                                  of CityGML files in many 3D based applications (OpenGL, OpenSceneGraph, ...)
                                  Most metadata are not lost, they are available through a per-node hashmap.

                                  CityGML (City Geography Markup Language) is an XML-based schema for the
                                  modelling and exchange of georeferenced 3D city and landscape models that
                                  is quickly being adopted on an international level.")
    set(META_AUTHOR_ORGANIZATION "3D Content Logistics")
    set(META_AUTHOR_DOMAIN       "https://github.com/jklimke/libcitygml.git")
    set(META_AUTHOR_MAINTAINER   "Marcel Pursche <marcel.pursche@3dcontentlogistics.com>")

    # Package information
    string(TOLOWER ${META_PROJECT_NAME} package_name)          # Package name
    set(CPACK_PACKAGE_NAME                  "${META_PROJECT_NAME}")
    set(CPACK_PACKAGE_VENDOR                "${META_AUTHOR_ORGANIZATION}")
    set(CPACK_PACKAGE_DESCRIPTION_SUMMARY   "${META_PROJECT_SUMMARY}")
    set(CPACK_PACKAGE_DESCRIPTION           "${META_PROJECT_DESCRIPTION}")
    set(CPACK_PACKAGE_VERSION               "${META_VERSION}")
    set(CPACK_PACKAGE_VERSION_MAJOR         "${META_VERSION_MAJOR}")
    set(CPACK_PACKAGE_VERSION_MINOR         "${META_VERSION_MINOR}")
    set(CPACK_PACKAGE_VERSION_PATCH         "${META_VERSION_PATCH}")
    set(CPACK_RESOURCE_FILE_LICENSE         "${CMAKE_SOURCE_DIR}/LICENSE")
    set(CPACK_PACKAGE_RELOCATABLE           OFF)

    # Debian package information
    set(CPACK_DEBIAN_PACKAGE_NAME           "${package_name}")
    set(CPACK_DEBIAN_PACKAGE_VERSION        "${CPACK_PACKAGE_VERSION}")
    set(CPACK_DEBIAN_PACKAGE_MAINTAINER     "${META_AUTHOR_MAINTAINER}")
    set(CPACK_DEBIAN_PACKAGE_DESCRIPTION    "${CPACK_PACKAGE_DESCRIPTION_SUMMARY}")
    set(CPACK_DEBIAN_PACKAGE_SECTION        "Development")
    set(CPACK_DEBIAN_PACKAGE_PRIORITY       "optional")
    set(CPACK_DEBIAN_PACKAGE_DEPENDS        "libgdal1h (>= 1.10.1), libxerces-c3.1 (>= 3.1.1-5)")
    set(CPACK_DEBIAN_PACKAGE_CONFLICTS      "libcitygml0, libcitygml0-dev")
    set(CPACK_DEBIAN_PACKAGE_HOMEPAGE       "${META_AUTHOR_DOMAIN}")
    set(CPACK_DEBIAN_PACKAGE_CONTROL_EXTRA  "${CMAKE_CURRENT_SOURCE_DIR}/debian_scripts/postinst;")
    
    set(CPACK_GENERATOR "DEB")

    include(CPack)
endif()

=== sources/CMakeLists.txt ===
SET( target citygml )

ADD_DEFINITIONS( -DCITYGML_LIBRARY )

ADD_DEFINITIONS( -DLIBCITYGML_BUILD )

IF( LIBCITYGML_STATIC )
  ADD_DEFINITIONS( -DLIBCITYGML_STATIC )
ENDIF( LIBCITYGML_STATIC )

IF( LIBCITYGML_DYNAMIC )
  ADD_DEFINITIONS( -DLIBCITYGML_DYNAMIC )
ENDIF( LIBCITYGML_DYNAMIC )

configure_file(include/citygml/citygml_api.h.in ${CMAKE_BINARY_DIR}/include/citygml/citygml_api.h)

INCLUDE_DIRECTORIES( ${CMAKE_SOURCE_DIR}/sources/include ${XERCESC_INCLUDE}  ${ICONV_INCLUDE_DIR} ${GLU_INCLUDE_PATH} ${GDAL_INCLUDE_DIR} ${CMAKE_BINARY_DIR}/include)

SET(SOURCES
  src/citygml/citymodel.cpp
  src/citygml/tesselator.cpp
  src/citygml/object.cpp
  src/citygml/featureobject.cpp
  src/citygml/appearance.cpp
  src/citygml/texture.cpp
  src/citygml/material.cpp
  src/citygml/georeferencedtexture.cpp
  src/citygml/envelope.cpp
  src/citygml/appearancemanager.cpp
  src/citygml/cityobject.cpp
  src/citygml/geometry.cpp
  src/citygml/implictgeometry.cpp
  src/citygml/linearring.cpp
  src/citygml/polygon.cpp
  src/citygml/transformmatrix.cpp
  src/citygml/texturetargetdefinition.cpp
  src/citygml/materialtargetdefinition.cpp
  src/citygml/texturecoordinates.cpp
  src/citygml/appearancetarget.cpp
  src/citygml/citygmlfactory.cpp
  src/citygml/polygonmanager.cpp
  src/citygml/geometrymanager.cpp
  src/citygml/linestring.cpp
  src/citygml/address.cpp

  src/parser/nodetypes.cpp
  src/parser/attributes.cpp

  src/parser/geocoordinatetransformer.cpp

  src/parser/citygmldocumentparser.cpp
  src/parser/parserxercesc.cpp
  src/parser/citygmlelementparser.cpp
  src/parser/elementparser.cpp

  src/parser/delayedchoiceelementparser.cpp
  src/parser/skipelementparser.cpp
  src/parser/sequenceparser.cpp

  src/parser/gmlobjectparser.cpp
  src/parser/gmlfeaturecollectionparser.cpp

  src/parser/citymodelelementparser.cpp
  src/parser/cityobjectelementparser.cpp
  src/parser/appearanceelementparser.cpp
  src/parser/materialelementparser.cpp
  src/parser/textureelementparser.cpp
  src/parser/georeferencedtextureelementparser.cpp
  src/parser/geometryelementparser.cpp
  src/parser/polygonelementparser.cpp
  src/parser/linestringelementparser.cpp
  src/parser/linearringelementparser.cpp
  src/parser/implicitgeometryelementparser.cpp
  src/parser/addressparser.cpp
)

SET(PUBLIC_HEADER
  ${CMAKE_BINARY_DIR}/include/citygml/citygml_api.h
  include/citygml/citygmllogger.h
  include/citygml/polygon.h
  include/citygml/material.h
  include/citygml/geometry.h
  include/citygml/object.h
  include/citygml/featureobject.h
  include/citygml/georeferencedtexture.h
  include/citygml/cityobject.h
  include/citygml/envelope.h
  include/citygml/appearance.h
  include/citygml/vecs.hpp
  include/citygml/citymodel.h
  include/citygml/linearring.h
  include/citygml/citygml.h
  include/citygml/transformmatrix.h
  include/citygml/implictgeometry.h
  include/citygml/tesselator.h
  include/citygml/texture.h
  include/citygml/appearancetargetdefinition.h
  include/citygml/texturetargetdefinition.h
  include/citygml/materialtargetdefinition.h
  include/citygml/texturecoordinates.h
  include/citygml/appearancetarget.h
  include/citygml/citygmlfactory.h
  include/citygml/linestring.h
  include/citygml/address.h
)

SET(HEADERS
  ${PUBLIC_HEADER}

  include/citygml/citygml_api.h.in

  include/citygml/tesselator.h
  include/citygml/utils.h
  include/citygml/appearancemanager.h
  include/citygml/polygonmanager.h
  include/citygml/geometrymanager.h

  include/parser/nodetypes.h
  include/parser/attributes.h
  include/parser/documentlocation.h

  include/parser/parserutils.hpp
  include/parser/geocoordinatetransformer.h

  include/parser/citygmldocumentparser.h
  include/parser/citygmlelementparser.h
  include/parser/elementparser.h

  include/parser/delayedchoiceelementparser.h
  include/parser/skipelementparser.h
  include/parser/sequenceparser.h

  include/parser/gmlobjectparser.h
  include/parser/gmlfeaturecollectionparser.h

  include/parser/citymodelelementparser.h
  include/parser/cityobjectelementparser.h
  include/parser/appearanceelementparser.h
  include/parser/materialelementparser.h
  include/parser/textureelementparser.h
  include/parser/georeferencedtextureelementparser.h
  include/parser/geometryelementparser.h
  include/parser/polygonelementparser.h
  include/parser/linestringelementparser.h
  include/parser/linearringelementparser.h
  include/parser/implicitgeometryelementparser.h
  include/parser/addressparser.h
)

ADD_LIBRARY( ${target} ${LIBCITYGML_USER_DEFINED_DYNAMIC_OR_STATIC} ${SOURCES} ${HEADERS} )

TARGET_LINK_LIBRARIES( ${target} ${XERCESC_LIBRARIES} ${OPENGL_LIBRARIES} ${GDAL_LIBRARY} )

INSTALL(
    TARGETS ${target}
    RUNTIME DESTINATION bin
    LIBRARY DESTINATION lib
    ARCHIVE DESTINATION lib
)
# FIXME: Do not run for OS X framework
INSTALL(
    FILES        ${PUBLIC_HEADER}
    DESTINATION  ${CMAKE_INSTALL_PREFIX}/include/${target}
)

=== test/CMakeLists.txt ===
IF(WIN32)
    SET(CMAKE_SHARED_LINKER_FLAGS_DEBUG "${CMAKE_SHARED_LINKER_FLAGS_DEBUG} /NODEFAULTLIB:MSVCRT")
ENDIF()

FIND_PACKAGE( OpenGL REQUIRED )
#FIND_PACKAGE( GLU REQUIRED ) # deprecated, GLU is now found with FindOpenGL

IF( COMMAND cmake_policy )
  cmake_policy( SET CMP0003 NEW )
ENDIF( COMMAND cmake_policy )

IF( LIBCITYGML_STATIC )
  ADD_DEFINITIONS( -DLIBCITYGML_STATIC )
ENDIF( LIBCITYGML_STATIC )

IF( LIBCITYGML_DYNAMIC )
  ADD_DEFINITIONS( -DLIBCITYGML_DYNAMIC )
ENDIF( LIBCITYGML_DYNAMIC )

IF( MSVC AND LIBCITYGML_STATIC_CRT )
  #We statically link to reduce dependancies
  FOREACH( flag_var CMAKE_CXX_FLAGS CMAKE_CXX_FLAGS_DEBUG CMAKE_CXX_FLAGS_RELEASE CMAKE_CXX_FLAGS_MINSIZEREL CMAKE_CXX_FLAGS_RELWITHDEBINFO )
    IF( ${flag_var} MATCHES "/MD" )
      string( REGEX REPLACE "/MD" "/MT" ${flag_var} "${${flag_var}}" )
    ENDIF( ${flag_var} MATCHES "/MD" )
    IF( ${flag_var} MATCHES "/MDd" )
      string( REGEX REPLACE "/MDd" "/MTd" ${flag_var} "${${flag_var}}" )
    ENDIF( ${flag_var} MATCHES "/MDd" )
  ENDFOREACH( flag_var )
ENDIF( MSVC AND LIBCITYGML_STATIC_CRT )

# INCLUDE_DIRECTORIES( ${CITYGML_INCLUDE_DIR} )
INCLUDE_DIRECTORIES( ${CMAKE_SOURCE_DIR}/sources/include ${CMAKE_BINARY_DIR}/include)

SET( PRG_SRCS citygmltest.cpp )

ADD_EXECUTABLE( citygmltest ${PRG_SRCS} )

# IF( MSVC_IDE )
  # SET_TARGET_PROPERTIES( citygmltest PROPERTIES PREFIX "../" )
# ENDIF( MSVC_IDE )

TARGET_LINK_LIBRARIES( citygmltest citygml ${XERCESC_LIBRARY} ${OPENGL_LIBRARIES} )

=== debian/changelog ===
libcitygml (1.4.3-1) unstable; urgency=medium

  * Team upload.
  * Drop explicit build dependencies on g++ (>= 4:5-0), g++-5 (>= 5.2.1-10).
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 24 Aug 2015 02:17:15 +0200

libcitygml (1.4.3-1~exp3) experimental; urgency=medium

  * Team upload.
  * Update symbols for other architectures.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 29 Jul 2015 18:03:28 +0200

libcitygml (1.4.3-1~exp2) experimental; urgency=medium

  * Fix version in Breaks/Replaces for experimental revisions.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 25 Jul 2015 13:23:34 +0200

libcitygml (1.4.3-1~exp1) experimental; urgency=medium

  * Team upload.
  * Update watch file for GitHub releases.
  * Add gbp.conf to use pristine-tar by default.
  * New upstream release.
  * Update Vcs-Browser URL to use cgit instead of gitweb.
  * Update Homepage & Source URLs for move to GitHub.
  * Update copyright file, use Comment instead of extended Copyright.
  * Refresh information-typo.diff patch.
  * Override dh_install to use --list-missing.
  * Split rewrite_cmake.diff into separate patches.
  * Add upstream metadata.
  * Drop citygml2vrml, no longer included upstream.
  * Drop SOVERSION from -dev & -bin package name.
  * Rename library package for SONAME bump.
  * Don't install static library, no longer built.
  * Drop openscenegraph plugin packages, FTBFS & disabled by default.
  * Add OpenGL build dependencies no longer pulled in by
    libopenscenegraph-dev.
  * Install all *.md files in docs.
  * Drop libcitygml-symbols.sh, only needed for initial symbols file
    creation.
  * Update symbols for amd64 with GCC 5.
  * Bump Standards-Version to 3.9.6, no changes.
  * Add explicit build dependencies on GCC 5.2.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 25 Jul 2015 01:21:25 +0200

=== debian/control ===
Source: libcitygml
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: YunQiang Su <wzssyqa@gmail.com>
Section: libs
Priority: optional
Build-Depends: debhelper (>= 9),
               cmake,
               libxml2-dev,
               libgdal-dev,
               libgl1-mesa-dev | libgl-dev,
               libglu-dev,
               pkg-kde-tools
Standards-Version: 3.9.6
Vcs-Browser: http://anonscm.debian.org/cgit/pkg-grass/libcitygml.git
Vcs-Git: git://anonscm.debian.org/pkg-grass/libcitygml.git
Homepage: https://github.com/jklimke/libcitygml

Package: libcitygml1
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Open source C++ library for parsing CityGML files
 libcitygml is a small and easy to use open source C++ library for parsing 
 CityGML files in such a way that data can be easily exploited by 3D 
 rendering applications (geometry data are tesselated and optimized for
 rendering during parsing). For instance, it can be used to develop readers 
 of CityGML files in many 3D based applications (OpenGL, OpenSceneGraph, ...) 
 Most metadata are not lost, they are available through a per-node hashmap.
 .
 CityGML (City Geography Markup Language) is an XML-based schema for the 
 modelling and exchange of georeferenced 3D city and landscape models that 
 is quickly being adopted on an international level.
 .
 This package contains share library.

Package: libcitygml-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libcitygml1 (= ${binary:Version}),
         ${misc:Depends},
Pre-Depends: ${misc:Pre-Depends}
Breaks: libcitygml0-dev (<< 1.4.3-1~)
Replaces: libcitygml0-dev (<< 1.4.3-1~)
Description: Static and header files of libcitygml
 libcitygml is a small and easy to use open source C++ library for parsing 
 CityGML files in such a way that data can be easily exploited by 3D 
 rendering applications (geometry data are tesselated and optimized for
 rendering during parsing). For instance, it can be used to develop readers 
 of CityGML files in many 3D based applications (OpenGL, OpenSceneGraph, ...) 
 Most metadata are not lost, they are available through a per-node hashmap.
 .
 CityGML (City Geography Markup Language) is an XML-based schema for the 
 modelling and exchange of georeferenced 3D city and landscape models that 
 is quickly being adopted on an international level.
 .
 This package contains develop files: static and header files of libcitygml.

Package: libcitygml-bin
Architecture: any
Section: utils
Depends: libcitygml1 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Breaks: libcitygml0-bin (<< 1.4.3-1~)
Replaces: libcitygml0-bin (<< 1.4.3-1~)
Description: Utils of libcitygml - citygmltest
 libcitygml is a small and easy to use open source C++ library for parsing 
 CityGML files in such a way that data can be easily exploited by 3D 
 rendering applications (geometry data are tesselated and optimized for
 rendering during parsing). For instance, it can be used to develop readers 
 of CityGML files in many 3D based applications (OpenGL, OpenSceneGraph, ...) 
 Most metadata are not lost, they are available through a per-node hashmap.
 .
 CityGML (City Geography Markup Language) is an XML-based schema for the 
 modelling and exchange of georeferenced 3D city and landscape models that 
 is quickly being adopted on an international level.
 .
 This package contains the citygmltest utility.

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE=1
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
CFLAGS += $(CPPFLAGS)
CXXFLAGS += $(CPPFLAGS)

CITYGML_VERSION=$(shell dpkg-parsechangelog | sed -ne 's/^Version: \(.*\)-.*/\1/p' | sed -e 's/\+.*//; s/^[0-9]://')

%:
	dh $@ --with pkgkde_symbolshelper

override_dh_auto_clean:
	dh_auto_clean
	-rm -rf obj-*-*

override_dh_install:
	dh_install --list-missing

override_dh_makeshlibs:
	dh_makeshlibs -- -c0 -v$(CITYGML_VERSION)

override_dh_auto_configure:
	dh_auto_configure -- \
		-DLIB_INSTALL_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)

## libcitygml 2.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,9 +2,9 @@
 
 PROJECT ( libcitygml )
 
-set(META_VERSION_MAJOR       "1")
-set(META_VERSION_MINOR       "4")
-set(META_VERSION_PATCH       "3")
+set(META_VERSION_MAJOR       "2")
+set(META_VERSION_MINOR       "0")
+set(META_VERSION_PATCH       "0")
 
 set(META_VERSION             "${META_VERSION_MAJOR}.${META_VERSION_MINOR}.${META_VERSION_PATCH}")
 
@@ -97,6 +97,28 @@
 MAKE_DIRECTORY(${OUTPUT_LIBDIR})
 SET(LIBRARY_OUTPUT_PATH ${OUTPUT_LIBDIR})
 
+if(NOT DEFINED BIN_INSTALL_DIR)
+    set(BIN_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/bin")
+endif(NOT DEFINED BIN_INSTALL_DIR)
+if(NOT DEFINED LIB_INSTALL_DIR)
+    set(LIB_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/lib")
+endif(NOT DEFINED LIB_INSTALL_DIR)
+if(NOT DEFINED DATA_INSTALL_DIR)
+    set(DATA_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/share")
+endif(NOT DEFINED DATA_INSTALL_DIR)
+if(NOT DEFINED INCLUDE_INSTALL_DIR)
+    set(INCLUDE_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/include/citygml")
+endif(NOT DEFINED INCLUDE_INSTALL_DIR)
+if(NOT DEFINED MAN_INSTALL_DIR)
+    set(MAN_INSTALL_DIR "${DATA_INSTALL_DIR}/man")
+endif(NOT DEFINED MAN_INSTALL_DIR)
+if(NOT DEFINED RESOURCE_INSTALL_DIR)
+    set(RESOURCE_INSTALL_DIR "${DATA_INSTALL_DIR}/libcitygml${META_VERSION_MAJOR}/resource/")
+endif(NOT DEFINED RESOURCE_INSTALL_DIR)
+if(NOT DEFINED LOCALE_INSTALL_DIR)
+    set(LOCALE_INSTALL_DIR "${DATA_INSTALL_DIR}/locale/")
+endif(NOT DEFINED LOCALE_INSTALL_DIR)
+
 # IF( DEBUG_BUILD )
   # SET( CMAKE_BUILD_TYPE "Debug" )
 # ELSE( DEBUG_BUILD )

=== osgplugin/CMakeLists.txt ===
set(target osgdb_citygml)

set_property(GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS ON)
find_package( OpenSceneGraph REQUIRED osgDB osgViewer osgGA osgUtil osgText)

include_directories(
  ${OPENSCENEGRAPH_INCLUDE_DIRS}
  ${CMAKE_SOURCE_DIR}/sources/include
  ${CMAKE_BINARY_DIR}/include
)

set( sources ReaderWriterCityGML.cpp )

add_library(${target} SHARED ${sources})
set_target_properties(${target} PROPERTIES PREFIX "")
if(APPLE)
    SET(CMAKE_SHARED_LIBRARY_SUFFIX ".so")
endif(APPLE)
target_link_libraries(${target} ${OPENSCENEGRAPH_LIBRARIES} citygml)

set(OSG_PLUGINS "osgPlugins-${OPENSCENEGRAPH_VERSION}")
set(LIBCITYGML_OSG_PLUGIN_INSTALL_DIR "" CACHE PATH "The directory in which the plugin will be installed. (osgPlugins-<version> is appended to this path)")

set(PLUGIN_INSTALL_PATH lib/${OSG_PLUGINS})
if (LIBCITYGML_OSG_PLUGIN_INSTALL_DIR)
  set(PLUGIN_INSTALL_PATH ${LIBCITYGML_OSG_PLUGIN_INSTALL_DIR}/${OSG_PLUGINS})
endif()

add_definitions(-DPLUGIN_BIN_DIR=\"${CMAKE_BINARY_DIR}/lib\")
add_executable(citygmlOsgViewer CitygmlOsgViewer.cpp)
target_link_libraries(citygmlOsgViewer ${OPENSCENEGRAPH_LIBRARIES} citygml)

INSTALL(
    TARGETS ${target}
    RUNTIME DESTINATION ${PLUGIN_INSTALL_PATH}
    LIBRARY DESTINATION ${PLUGIN_INSTALL_PATH}
    ARCHIVE DESTINATION ${PLUGIN_INSTALL_PATH}
)

INSTALL(
    TARGETS citygmlOsgViewer
    RUNTIME DESTINATION bin
    LIBRARY DESTINATION ${PLUGIN_INSTALL_PATH}
    ARCHIVE DESTINATION ${PLUGIN_INSTALL_PATH}
)

=== sources/CMakeLists.txt ===
--- 
+++ 
@@ -151,15 +151,23 @@
 
 TARGET_LINK_LIBRARIES( ${target} ${XERCESC_LIBRARIES} ${OPENGL_LIBRARIES} ${GDAL_LIBRARY} )
 
+set_target_properties( ${target} PROPERTIES
+    VERSION ${META_VERSION}
+    SOVERSION ${META_VERSION_MAJOR}
+)
+
 INSTALL(
     TARGETS ${target}
-    RUNTIME DESTINATION bin
-    LIBRARY DESTINATION lib
-    ARCHIVE DESTINATION lib
+    RUNTIME DESTINATION ${BIN_INSTALL_DIR}
+    LIBRARY DESTINATION ${LIB_INSTALL_DIR}
+    ARCHIVE DESTINATION ${LIB_INSTALL_DIR}
 )
 # FIXME: Do not run for OS X framework
 INSTALL(
     FILES        ${PUBLIC_HEADER}
-    DESTINATION  ${CMAKE_INSTALL_PREFIX}/include/${target}
+    DESTINATION  ${INCLUDE_INSTALL_DIR}
 )
 
+configure_file(citygml.pc.cmake ${CMAKE_CURRENT_BINARY_DIR}/citygml.pc)
+install(FILES ${CMAKE_CURRENT_BINARY_DIR}/citygml.pc DESTINATION ${LIB_INSTALL_DIR}/pkgconfig)
+

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -41,3 +41,6 @@
 # ENDIF( MSVC_IDE )
 
 TARGET_LINK_LIBRARIES( citygmltest citygml ${XERCESC_LIBRARY} ${OPENGL_LIBRARIES} )
+
+install(TARGETS citygmltest RUNTIME DESTINATION ${BIN_INSTALL_DIR})
+

=== debian/changelog ===
libcitygml (2.0-3) unstable; urgency=medium

  * Team upload.
  * Bump Standards-Version to 3.9.8, no changes.
  * Enable all hardening buildflags.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 05 May 2016 12:55:25 +0200

libcitygml (2.0-2) unstable; urgency=medium

  * Team upload.
  * Update Vcs-Git URL to use HTTPS.
  * Add patch for 'occurred' typo.
  * Bump Standards-Version to 3.9.7, no changes.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 02 Mar 2016 20:17:49 +0100

libcitygml (2.0-1) unstable; urgency=medium

  * Team upload.
  * Update symbols for other architectures.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 11 Sep 2015 18:44:41 +0200

libcitygml (2.0-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
  * Drop patches, applied upstream.
  * Update Vcs-Browser URL to use HTTPS.
  * Rename library package for SONAME bump.
  * Update symbols for amd64.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 31 Aug 2015 23:13:31 +0200

=== debian/control ===
Source: libcitygml
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: YunQiang Su <wzssyqa@gmail.com>
Section: libs
Priority: optional
Build-Depends: debhelper (>= 9),
               cmake,
               libxml2-dev,
               libgdal-dev,
               libgl1-mesa-dev | libgl-dev,
               libglu-dev,
               pkg-kde-tools
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-grass/libcitygml.git
Vcs-Git: https://anonscm.debian.org/git/pkg-grass/libcitygml.git
Homepage: https://github.com/jklimke/libcitygml

Package: libcitygml2
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Open source C++ library for parsing CityGML files
 libcitygml is a small and easy to use open source C++ library for parsing
 CityGML files in such a way that data can be easily exploited by 3D
 rendering applications (geometry data are tesselated and optimized for
 rendering during parsing). For instance, it can be used to develop readers
 of CityGML files in many 3D based applications (OpenGL, OpenSceneGraph, ...)
 Most metadata are not lost, they are available through a per-node hashmap.
 .
 CityGML (City Geography Markup Language) is an XML-based schema for the
 modelling and exchange of georeferenced 3D city and landscape models that
 is quickly being adopted on an international level.
 .
 This package contains share library.

Package: libcitygml-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libcitygml2 (= ${binary:Version}),
         ${misc:Depends},
Pre-Depends: ${misc:Pre-Depends}
Breaks: libcitygml0-dev (<< 1.4.3-1~)
Replaces: libcitygml0-dev (<< 1.4.3-1~)
Description: Static and header files of libcitygml
 libcitygml is a small and easy to use open source C++ library for parsing
 CityGML files in such a way that data can be easily exploited by 3D
 rendering applications (geometry data are tesselated and optimized for
 rendering during parsing). For instance, it can be used to develop readers
 of CityGML files in many 3D based applications (OpenGL, OpenSceneGraph, ...)
 Most metadata are not lost, they are available through a per-node hashmap.
 .
 CityGML (City Geography Markup Language) is an XML-based schema for the
 modelling and exchange of georeferenced 3D city and landscape models that
 is quickly being adopted on an international level.
 .
 This package contains develop files: static and header files of libcitygml.

Package: libcitygml-bin
Architecture: any
Section: utils
Depends: libcitygml2 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Breaks: libcitygml0-bin (<< 1.4.3-1~)
Replaces: libcitygml0-bin (<< 1.4.3-1~)
Description: Utils of libcitygml - citygmltest
 libcitygml is a small and easy to use open source C++ library for parsing
 CityGML files in such a way that data can be easily exploited by 3D
 rendering applications (geometry data are tesselated and optimized for
 rendering during parsing). For instance, it can be used to develop readers
 of CityGML files in many 3D based applications (OpenGL, OpenSceneGraph, ...)
 Most metadata are not lost, they are available through a per-node hashmap.
 .
 CityGML (City Geography Markup Language) is an XML-based schema for the
 modelling and exchange of georeferenced 3D city and landscape models that
 is quickly being adopted on an international level.
 .
 This package contains the citygmltest utility.

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,12 @@
 #!/usr/bin/make -f
+
 export DH_VERBOSE=1
+
+# Enable hardening build flags
+export DEB_BUILD_MAINT_OPTIONS=hardening=+all
+
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
+
 CFLAGS += $(CPPFLAGS)
 CXXFLAGS += $(CPPFLAGS)
 
@@ -13,12 +19,13 @@
 	dh_auto_clean
 	-rm -rf obj-*-*
 
+override_dh_auto_configure:
+	dh_auto_configure -- \
+		-DLIB_INSTALL_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)
+
 override_dh_install:
 	dh_install --list-missing
 
 override_dh_makeshlibs:
 	dh_makeshlibs -- -c0 -v$(CITYGML_VERSION)
 
-override_dh_auto_configure:
-	dh_auto_configure -- \
-		-DLIB_INSTALL_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)

=== debian/watch ===
version=3
opts=\
dversionmangle=s/\+(debian|dfsg|ds|deb)\d*$//,\
uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/;s/RC/rc/;s/-/./g,\
filenamemangle=s/(?:.*)?(?:rel|v|libcitygml)[\-\_]?(\d\S+)\.(tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))/libcitygml-$1.$2/ \
https://github.com/jklimke/libcitygml/releases \
(?:.*/)?(?:rel|v|libcitygml)[\-\_]?(\d\S+)\.(?:tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## libcitygml 2.0.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,10 +1,10 @@
-CMAKE_MINIMUM_REQUIRED(VERSION 2.8.2 FATAL_ERROR)
+CMAKE_MINIMUM_REQUIRED(VERSION 3.0.0 FATAL_ERROR)
 
 PROJECT ( libcitygml )
 
 set(META_VERSION_MAJOR       "2")
 set(META_VERSION_MINOR       "0")
-set(META_VERSION_PATCH       "0")
+set(META_VERSION_PATCH       "4")
 
 set(META_VERSION             "${META_VERSION_MAJOR}.${META_VERSION_MINOR}.${META_VERSION_PATCH}")

=== sources/CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,4 @@
+include(GenerateExportHeader)
 SET( target citygml )
 
 ADD_DEFINITIONS( -DCITYGML_LIBRARY )
@@ -14,9 +15,18 @@
 
 configure_file(include/citygml/citygml_api.h.in ${CMAKE_BINARY_DIR}/include/citygml/citygml_api.h)
 
-INCLUDE_DIRECTORIES( ${CMAKE_SOURCE_DIR}/sources/include ${XERCESC_INCLUDE}  ${ICONV_INCLUDE_DIR} ${GLU_INCLUDE_PATH} ${GDAL_INCLUDE_DIR} ${CMAKE_BINARY_DIR}/include)
+SET(EXPORT_HEADER_FILE_NAME ${PROJECT_BINARY_DIR}/include/citygml/citygml_export.h)
+
+INCLUDE_DIRECTORIES( ${CMAKE_SOURCE_DIR}/sources/include
+                        ${XERCESC_INCLUDE}
+                        ${ICONV_INCLUDE_DIR}
+                        ${GLU_INCLUDE_PATH}
+                        ${GDAL_INCLUDE_DIR}
+                        ${CMAKE_BINARY_DIR}/include
+                        ${PROJECT_BINARY_DIR}/include)
 
 SET(SOURCES
+  src/citygml/attributesmap.cpp
   src/citygml/citymodel.cpp
   src/citygml/tesselator.cpp
   src/citygml/object.cpp
@@ -73,9 +83,17 @@
   src/parser/implicitgeometryelementparser.cpp
   src/parser/addressparser.cpp
 )
+if(UNIX)
+  if (APPLE)
+    set_source_files_properties(src/citygml/tesselator.cpp PROPERTIES COMPILE_FLAGS "-Wno-deprecated-declarations") # for warnings: 'glu*' is deprecated...
+  endif (APPLE)
+endif(UNIX)
 
 SET(PUBLIC_HEADER
   ${CMAKE_BINARY_DIR}/include/citygml/citygml_api.h
+  ${CMAKE_BINARY_DIR}/include/citygml/citygml_export.h
+  include/citygml/attributesmap.h
+  include/citygml/enum_type_bitmask.h
   include/citygml/citygmllogger.h
   include/citygml/polygon.h
   include/citygml/material.h
@@ -149,6 +167,11 @@
 
 ADD_LIBRARY( ${target} ${LIBCITYGML_USER_DEFINED_DYNAMIC_OR_STATIC} ${SOURCES} ${HEADERS} )
 
+
+generate_export_header(citygml
+                        EXPORT_MACRO_NAME LIBCITYGML_EXPORT
+                        EXPORT_FILE_NAME ${EXPORT_HEADER_FILE_NAME})
+
 TARGET_LINK_LIBRARIES( ${target} ${XERCESC_LIBRARIES} ${OPENGL_LIBRARIES} ${GDAL_LIBRARY} )
 
 set_target_properties( ${target} PROPERTIES
@@ -162,12 +185,24 @@
     LIBRARY DESTINATION ${LIB_INSTALL_DIR}
     ARCHIVE DESTINATION ${LIB_INSTALL_DIR}
 )
+
+
 # FIXME: Do not run for OS X framework
 INSTALL(
-    FILES        ${PUBLIC_HEADER}
+    FILES        
+      ${PUBLIC_HEADER}
     DESTINATION  ${INCLUDE_INSTALL_DIR}
 )
 
+INSTALL(
+    FILES        
+      ${EXPORT_HEADER_FILE_NAME}
+    DESTINATION  
+      ${INCLUDE_INSTALL_DIR}
+)
+      
+
 configure_file(citygml.pc.cmake ${CMAKE_CURRENT_BINARY_DIR}/citygml.pc)
+
 install(FILES ${CMAKE_CURRENT_BINARY_DIR}/citygml.pc DESTINATION ${LIB_INSTALL_DIR}/pkgconfig)

=== debian/changelog ===
libcitygml (2.0.4-1build1) artful; urgency=medium

  * Rebuild against new gdal ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 13 Jul 2017 13:03:10 +0200

libcitygml (2.0.4-1) unstable; urgency=medium

  * Team upload.
  * Bump Standards-Version to 4.0.0, no changes.
  * Add autopkgtest to test installability.
  * Use pkg-info.mk variables instead of dpkg-parsechangelog output.
  * Add patch to fix spelling errors.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 18 Jun 2017 22:15:27 +0200

libcitygml (2.0.4-1~exp2) experimental; urgency=medium

  * Team upload.
  * Add upstream patch to fix FTBFS with GCC 7.
    (closes: #853487)

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 24 Feb 2017 10:06:23 +0100

libcitygml (2.0.4-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
  * Drop occurred-typo.patch, applied upstream.
  * Disable DH_VERBOSE in rules file.
  * Update symbols for amd64.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 20 Jan 2017 16:44:47 +0100

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
                libgl1-mesa-dev | libgl-dev,
                libglu-dev,
                pkg-kde-tools
-Standards-Version: 3.9.8
+Standards-Version: 4.0.0
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-grass/libcitygml.git
 Vcs-Git: https://anonscm.debian.org/git/pkg-grass/libcitygml.git
 Homepage: https://github.com/jklimke/libcitygml
